<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CustomAuditEventRepository.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.repository</a> &gt; <span class="el_source">CustomAuditEventRepository.java</span></div><h1>CustomAuditEventRepository.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.repository;

import br.edu.unifacisa.lti.config.Constants;
import br.edu.unifacisa.lti.config.audit.AuditEventConverter;
import br.edu.unifacisa.lti.domain.PersistentAuditEvent;

import org.springframework.boot.actuate.audit.AuditEvent;
import org.springframework.boot.actuate.audit.AuditEventRepository;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.List;

/**
 * An implementation of Spring Boot's AuditEventRepository.
 */
@Repository
public class CustomAuditEventRepository implements AuditEventRepository {

    private static final String AUTHORIZATION_FAILURE = &quot;AUTHORIZATION_FAILURE&quot;;

    private final PersistenceAuditEventRepository persistenceAuditEventRepository;

    private final AuditEventConverter auditEventConverter;

    public CustomAuditEventRepository(PersistenceAuditEventRepository persistenceAuditEventRepository,
<span class="fc" id="L32">            AuditEventConverter auditEventConverter) {</span>

<span class="fc" id="L34">        this.persistenceAuditEventRepository = persistenceAuditEventRepository;</span>
<span class="fc" id="L35">        this.auditEventConverter = auditEventConverter;</span>
<span class="fc" id="L36">    }</span>

    @Override
    public List&lt;AuditEvent&gt; find(Date after) {
<span class="nc" id="L40">        Iterable&lt;PersistentAuditEvent&gt; persistentAuditEvents =</span>
<span class="nc" id="L41">            persistenceAuditEventRepository.findByAuditEventDateAfter(LocalDateTime.from(after.toInstant()));</span>
<span class="nc" id="L42">        return auditEventConverter.convertToAuditEvent(persistentAuditEvents);</span>
    }

    @Override
    public List&lt;AuditEvent&gt; find(String principal, Date after) {
        Iterable&lt;PersistentAuditEvent&gt; persistentAuditEvents;
<span class="nc bnc" id="L48" title="All 4 branches missed.">        if (principal == null &amp;&amp; after == null) {</span>
<span class="nc" id="L49">            persistentAuditEvents = persistenceAuditEventRepository.findAll();</span>
<span class="nc bnc" id="L50" title="All 2 branches missed.">        } else if (after == null) {</span>
<span class="nc" id="L51">            persistentAuditEvents = persistenceAuditEventRepository.findByPrincipal(principal);</span>
        } else {
<span class="nc" id="L53">            persistentAuditEvents =</span>
<span class="nc" id="L54">                persistenceAuditEventRepository.findByPrincipalAndAuditEventDateAfter(principal, LocalDateTime.from(after.toInstant()));</span>
        }
<span class="nc" id="L56">        return auditEventConverter.convertToAuditEvent(persistentAuditEvents);</span>
    }

    @Override
    public List&lt;AuditEvent&gt; find(String principal, Date after, String type) {
<span class="nc" id="L61">        Iterable&lt;PersistentAuditEvent&gt; persistentAuditEvents =</span>
<span class="nc" id="L62">            persistenceAuditEventRepository.findByPrincipalAndAuditEventDateAfterAndAuditEventType(principal, LocalDateTime.from(after.toInstant()), type);</span>
<span class="nc" id="L63">        return auditEventConverter.convertToAuditEvent(persistentAuditEvents);</span>
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRES_NEW)
    public void add(AuditEvent event) {
<span class="nc bnc" id="L69" title="All 2 branches missed.">        if (!AUTHORIZATION_FAILURE.equals(event.getType()) &amp;&amp;</span>
<span class="nc bnc" id="L70" title="All 2 branches missed.">            !Constants.ANONYMOUS_USER.equals(event.getPrincipal())) {</span>

<span class="nc" id="L72">            PersistentAuditEvent persistentAuditEvent = new PersistentAuditEvent();</span>
<span class="nc" id="L73">            persistentAuditEvent.setPrincipal(event.getPrincipal());</span>
<span class="nc" id="L74">            persistentAuditEvent.setAuditEventType(event.getType());</span>
<span class="nc" id="L75">            Instant instant = Instant.ofEpochMilli(event.getTimestamp().getTime());</span>
<span class="nc" id="L76">            persistentAuditEvent.setAuditEventDate(LocalDateTime.ofInstant(instant, ZoneId.systemDefault()));</span>
<span class="nc" id="L77">            persistentAuditEvent.setData(auditEventConverter.convertDataToStrings(event.getData()));</span>
<span class="nc" id="L78">            persistenceAuditEventRepository.save(persistentAuditEvent);</span>
        }
<span class="nc" id="L80">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>